#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id$
#$Log$

require 'query-string.pl';
require 'html-util.pl';
require 'set-env.pl';

#>-----------------------------------------------------------------<
#> Function    : prints out an ascii file's contents onto stdout.
#> In Arguments: file's name ($FName)
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_File{
   local($FName) = @_;
   open(InFile, $FName) || do htmlDie("Print_File:$!");
   print "\n$FName:\n";
   while (<InFile>) {
      print $_;
   }
   close(InFile);
}


#>-----------------------------------------------------------------<
#> Function    : saves contents of code given by user into a temp file.
#> In Arguments: name of temp file  ($outFName)
#> Side Effect : a scratch file and a temp file are created.
#>-----------------------------------------------------------------<
sub Save_User_File {
   local($outFile) = @_;
   local($tempFile) = "WEB_Demo.tmp";
   open(OUT, "> $tempFile") || &htmlDie("Can't open $tempFile");
   print OUT $MYDATA{'PROGRAM.CODE'};
   close OUT || &htmlDie("Can't close $tempFile \n");

   open(IN, $tempFile) || &htmlDie("Can't open $tempFile ");
   open(OUT, "> $outFile") || &htmlDie("Can't open $outFile ");
   while (<IN>) {
     chop($_);    #still deletes the END if it is not terminated by \n
     chop($_);
     if (/^\\n/)  { ;} 
     else {
        print OUT "$_\n";
     }
   }
   close OUT || &htmlDie("Can't close $outFile \n");
}

#>-----------------------------------------------------------------<
#> Function    : copies requested demo file into EditFile
#> In Arguments: Name of demo program.
#> Side Effect : EditFile is updated. 
#>-----------------------------------------------------------------<   
sub DoGoBack {
   local($url, $doc) = @_;
   if ($url eq "") {
      &htmlDie("No URL name supplied.");
   }
   $LOCATION = $url . $doc;
   print STDOUT "Location: $LOCATION\n\n";
   die;
}

#>-----------------------------------------------------------------<
#> Function    : prints HTML page header for the monitor page.
#> In Arguments: none.
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_Page_Header {
  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<TITLE></TITLE>\n";
  print "</HEAD>\n";
  print '<BODY BGCOLOR="white" TEXT="black">';
  print "<FORM>";
  print '<CENTER>
         <H2><FONT COLOR="green">Results of Submitted Process</H2> 
         </CENTER><HR></FONT>';
}



#>-----------------------------------------------------------------<
#> Function    : sets all flags and variables used in this script 
#>               according to user's selections.
#> In Arguments: $MY_DATA
#> Side Effect : All variables/flags given below are set.
#>-----------------------------------------------------------------<
sub Set_Compiler_Flags{
    local($i, $fldname);

    $inputfile     = $MYDATA{'INPUT_FILE'}; 
    $outputfile    = $MYDATA{'OUTPUT_FILE'};
}

#>-----------------------------------------------------------------<
#> Function    : prints debugging statements.
#> In Arguments: chosen variables/flags of the script.
#> Side Effect : Chosen variables/flags are printed out.
#>-----------------------------------------------------------------<
sub Print_Debugging_Stmts {
    print "A few debugging stmts:";
    print "<blockquote>";

    print "username: $username <br>";

    print "</blockquote>";
    print "End of the debugging stmts<p>";
}

#
# -------------------- M A I N --------------------
#
   &Read_Query_String();
   &Parse_Query_String();
   &Define_Constants();

#>
#>-Fill in parameters 
#> 
    $cmnd = $MYDATA{'CMND'};
    $file = $MYDATA{'FILENAME'};
    $dir = $MYDATA{'DIRNAME'};
    $dest= $MYDATA{'DEST'};

   #&Print_Page_Header();
   if ($cmnd eq "MKDIR") {
       $temp = $DemoDir . $dest;
       mkdir($temp, 0777) || &htmlDie("Can't mkdir $temp <BR>");
   }
   elsif ($cmnd eq "RMDIR") {
       $temp = $DemoDir . $dir;
       rmdir($temp) || &htmlDie("Can't rmdir $temp <BR>"); 
   }
   elsif ($cmnd eq "RENDIR") {
       $temp = $DemoDir . $dir;
       $temp2 = $DemoDir . $dest;
       #rename($temp, $temp2) || &htmlDie("Can't rename $temp $temp2<BR>");
       $stat = system("mv $temp $temp2"); 
       if ($stat) { &htmlDie("Can't rename $dir as $dest <BR>");}
       if ($stat) { &htmlDie("Can't rename $temp as $temp2 <BR>");}
   }
   elsif ($cmnd eq "COPY") {
       #print "\n I will do:  cp $file $dest <BR>\n";
       $temp = $DemoDir . $dir . "/". $file;
       $temp2= $DemoDir . "/" . $dest;
       $stat = system("cp $temp $temp2");
       if ($stat) { &htmlDie("Can't cp $temp $temp2 <BR>");} 
   }
   elsif ($cmnd eq "RM") {
       $temp = $DemoDir . $dir . "/" . $file;
       #print "\n I will do: unlink $temp <BR>\n";
       unlink($temp) || &htmlDie("Can't unlink $temp <BR>"); ; 
   }
   elsif ( $cmnd eq "REN") {
       $temp = $DemoDir . $dir . "/" . $file;
       $temp2 = $DemoDir . $dir . "/" . $dest;
       #print "\n I will do: rename $temp $temp2<BR>\n";
       rename($temp, $temp2) || &htmlDie("Can't rename $temp $temp2 <BR>"); ;
   }  
   else {
       &htmlDie ("Unknown command");
   }
    sleep(0);
    &DoGoBack($DocURL, $OutlineDocName); 
    &htmlDie("Never supposed to return here!");

#end_of_file

