#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id$
#$Log$

require 'query-string.pl';
require 'html-util.pl';
require 'set-env.pl';

#>-----------------------------------------------------------------<
#> Function    : saves contents of code given by user into a temp file.
#> In Arguments: name of temp file  ($outFName)
#> Side Effect : a scratch file and a temp file are created.
#>-----------------------------------------------------------------<
sub DoOpen {
   local($inFile) = @_;
   local($outFile)= $EditFile;

   open(IN, $inFile) || &htmlDie("Can't open $inFile ");
   open(OUT, "> $outFile") || &htmlDie("Can't open $outFile ");
   print OUT "$dirname\n";
   print OUT "$filename\n";
   while (<IN>) {
       print OUT $_;
   }
   close IN || &htmlDie("Can't close $inFile \n");
   close OUT || &htmlDie("Can't close $outFile \n");
}

sub DoNew{
   local($outFile)= $EditFile;

   open(OUT, "> $outFile") || &htmlDie("Can't open $outFile ");
   print OUT "$dirname\n";
   print OUT "$filename\n";
   while (<IN>) {
       print OUT "";
   }
   close OUT || &htmlDie("Can't close $outFile \n");
}

sub DoGoBack {
   $DocName = "/vpl2.0/dir-file-info.html";  #FIX
   $LOCATION = $DocURL . $DocName;
   print STDOUT "Location: $LOCATION\n\n";
}

#>-----------------------------------------------------------------<
#> Function    : prints HTML page header for the monitor page.
#> In Arguments: none.
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_Page_Header {
  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<TITLE></TITLE>\n";
  print "</HEAD>\n";
  print '<BODY BGCOLOR="white" TEXT="black">';
  print "<FORM>";
  #print '<CENTER>
         #<H2><FONT COLOR="green">Results of Submitted Process</H2> 
         #</CENTER><HR></FONT>';
}

#>-----------------------------------------------------------------<
#> Function    : prints debugging statements.
#> In Arguments: chosen variables/flags of the script.
#> Side Effect : Chosen variables/flags are printed out.
#>-----------------------------------------------------------------<
sub Print_Debugging_Stmts {
    print "A few debugging stmts:";
    print "<blockquote>";

    print "username: $username <br>";

    print "cmnd    : $cmnd  <br>";
    print "dirname : $dirname <br>";
    print "filename: $filename <br>";

    print "</blockquote>";
    print "End of the debugging stmts<p>";
}

#
# -------------------- M A I N --------------------
#
   &Read_Query_String();
   &Parse_Query_String();
   &Define_Constants();

   $cmnd = $MYDATA{'CMND'};
   $filename = $MYDATA{'FILENAME'};
   $dirname = $MYDATA{'DIRNAME'};
#>
#>-Fill in parameters 
#> 
    if ($cmnd eq "OPEN") {
       do DoOpen($DemoDir.$dirname."/".$filename);
    }
    elsif ($cmnd eq "NEW") {
       do DoNew(); 
    } else {
       do htmlDie("Unknown command!"); 
    }
 
    &Print_Page_Header();
    #print "<HTML>";
    print "</BODY>\n";
   print "</HTML>\n";

