#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id$
#$Log$

require 'query-string.pl';
require 'html-util.pl';
require 'set-env.pl';


#>-----------------------------------------------------------------<
#> Function    : saves contents of code given by user into a temp file.
#> In Arguments: name of temp file  ($outFName)
#>               $TempFile (global var. defined in set-env.pl
#> Side Effect : a scratch file and a temp file are created.
#>-----------------------------------------------------------------<
sub DoSaveOld {
   local($outFile) = @_;
   local($tempFile) = $TempFile; 
   open(OUT, "> $tempFile") || &htmlDie("Can't open $tempFile");
   print OUT $MYDATA{'TEXT'};
   close OUT || &htmlDie("Can't close $tempFile \n");
   if ($cmnd eq "SAVE") {rename($outfile, $outfile.v2);}
   
   local($offset) = index($outFile, "class-accounts/".$username); 
   local($target) = substr($outFile,$offset+length("class-accounts/"));
   &htmlPrintwOpen("Saving <B>$target</B>... <BR>");
   rename($tempFile, $outFile) || &htmlDie("Can't save $outFile \n");
   &htmlPrint("File saved successfully!<BR>");
}

sub DoSave {
   local($outFile) = @_;
   local($tempFile)= $TempFile;
   open(OUT, "> $tempFile") || &htmlDie("Can't open $tempFile");
   print OUT $MYDATA{'TEXT'};
   close OUT || &htmlDie("Can't close $tempFile \n");

   open(IN, "< $tempFile") || &htmlDie("Can't open $tempFile");
   open(OUT, "> $outFile") || &htmlDie("Can't open $outFile");
   while (<IN>) {
      print OUT $_; 
   }
   close IN || &htmlDie("Can't close $tempFile \n");
   close OUT || &htmlDie("Can't close $outFile \n");

   local($offset) = index($outFile, "class-accounts/".$username); 
   local($target) = substr($outFile,$offset+length("class-accounts/"));
   &htmlPrintwOpen("Saving <B>$target</B>... <BR>");
   &htmlPrint("File saved successfully!<BR>");
}

#>-----------------------------------------------------------------<
#> Function    : prints debugging statements.
#> In Arguments: chosen variables/flags of the script.
#> Side Effect : Chosen variables/flags are printed out.
#>-----------------------------------------------------------------<
sub Print_Debugging_Stmts {
    print "A few debugging stmts:";
    print "<blockquote>";

    print "username: $username <br>";

    print "cmnd    : $cmnd  <br>";
    print "dirname : $dirname <br>";
    print "filename: $filename <br>";
    print "dest    : $dest  <br>";
    print "</blockquote>";
    print "End of the debugging stmts<p>";
}

#
# -------------------- M A I N --------------------
#
   &Read_Query_String();
   &Parse_Query_String();
   &Define_Constants();

   $cmnd = $MYDATA{'CMND'};
   $filename = $MYDATA{'FILENAME'};
   $dirname = $MYDATA{'DIRNAME'};
   $dest = $MYDATA{'DEST'};
   #&Print_Debugging_Stmts();
#>
#>-Fill in parameters 
#> 
    if ($cmnd eq "SAVE")  {      # OPEN was selected. 
       do DoSave($DemoDir."$dirname/$filename");
    }elsif ($cmnd eq "SAVEAS")  {      # OPEN was selected. 
       do DoSave($DemoDir.$dest);
    }else {
       do htmlDie("Unknown command: \"$cmnd\" !"); 
    }

   print "</BODY>\n";
   print "</HTML>\n";

