#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id: hpf-demo.pl,v 1.1 1996/08/21 04:41:32 dincer Exp dincer $
#$Log: hpf-demo.pl,v $
#Revision 1.1  1996/08/21 04:41:32  dincer
#Actually this is the second version, I lost the rcs files for 
# the initial version and had to regenerate the rcs files.
#
#% Revision 1.1  1996/07/26  15:01:51  dincer
#% Initial revision
#% Author: Kivanc Dincer, NPAC 1996.

require 'query-string.pl';
require 'html-util.pl';
require 'set-env.pl';

#>-----------------------------------------------------------------<
#> Function    : prints out an ascii file's contents onto stdout.
#> In Arguments: file's name ($FName)
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_File{
   local($FName) = @_;
   open(InFile, $FName) || do htmlDie("Print_File:$!");
   print "\n$FName:\n";
   while (<InFile>) {
      print $_;
   }
   close(InFile);
}


#>-----------------------------------------------------------------<
#> Function    : saves contents of code given by user into a temp file.
#> In Arguments: name of temp file  ($outFName)
#> Side Effect : a scratch file and a temp file are created.
#>-----------------------------------------------------------------<
sub Save_User_File {
   local($outFile) = @_;
   local($tempFile) = "WEB_Demo.tmp";
   open(OUT, "> $tempFile") || &htmlDie("Can't open $tempFile");
   print OUT $MYDATA{'PROGRAM.CODE'};
   close OUT || &htmlDie("Can't close $tempFile \n");

   open(IN, $tempFile) || &htmlDie("Can't open $tempFile ");
   open(OUT, "> $outFile") || &htmlDie("Can't open $outFile ");
   while (<IN>) {
     chop($_);    #still deletes the END if it is not terminated by \n
     chop($_);
     if (/^\\n/)  { ;} 
     else {
        print OUT "$_\n";
     }
   }
   close OUT || &htmlDie("Can't close $outFile \n");
}

#>-----------------------------------------------------------------<
#> Function    : copies requested demo file into EditFile
#> In Arguments: Name of demo program.
#> Side Effect : EditFile is updated. 
#>-----------------------------------------------------------------<   
sub DoImport {
   local($program) = @_;

   $routine = "DoImport";
   if ($program eq "") {
      &htmlDie("No program name supplied.");
   }
   open(DEMOF, "<$program")||&htmlDie("DoImport: (open $program) -> $!");
   #do htmlPrint("$DocDir/EditWindow.in");
  
   open(EDITF, ">$EditFile")||&htmlDie("DoImport: (open $EditFile) -> $!");
   #print EDITF "C* Program Name:$program \n";
   while (<DEMOF>) {
      print EDITF $_;
   }
   close(DEMOF);
   close(EDITF);

   select(STDOUT); $|=1;   

   $DocName = "mpi.shtml";
   $LOCATION = $DocURL . $DocName;
   print STDOUT "Location: $LOCATION\n\n";
   &htmlDie("DoImport: Never supposed to reach here!");
}

#>-----------------------------------------------------------------<
#> Function    : redirects stderr and stdout.
#> In Arguments: names of new targets for stderr($err) and stdout($out).
#> Side Effect : on stderr and stdout.
#>-----------------------------------------------------------------<
sub StartSwitchOut {
   local($out, $err) = @_;
   unlink($out)|| print STDOUT "Unlink $out. \n";
   unlink($err)|| print STDOUT "Unlink $err. \n";
   $routine = "StartSwitchOut";
   open(SAVEOUT, ">&STDOUT");
   open(STDOUT,">$out")||do htmlPrint("Can't dup:$!");
   select(STDOUT); $|=1;
   open(SAVEERR, ">&STDERR");  
   open(STDERR,">$err")||do htmlPrint("Can't dup:$!");
   select(STDERR); $|=1;
}

#>-----------------------------------------------------------------<
#> Function    : redirects stderr and stdout to their default values.
#> In Arguments: none.
#> Side Effect : on stderr and stdout.
#>-----------------------------------------------------------------<
sub EndSwitchOut {
   close(STDOUT);
   open(STDOUT, ">&SAVEOUT");
   close(STDERR);
   open(STDERR, ">&SAVEERR");
   select(STDOUT); $|=1;
}

#>-----------------------------------------------------------------<
#> Function    : prints HTML page header for the monitor page.
#> In Arguments: none.
#> Side Effect : on stdout.
#>-----------------------------------------------------------------<
sub Print_Page_Header {
  print "Content-type: text/html\n\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<TITLE>HPF Compilation System</TITLE>\n";
  print "</HEAD>\n";
  print '<BODY>';  # BGCOLOR="#A6CAF0" TEXT="#00000">';
  print "<FORM>";
  print "<H2>Monitor Page</H2>";
}

#>-----------------------------------------------------------------<
#> Function    : manages the HPF to F77+MP  translation by using Makefile.
#> In Arguments: names of the HPF and F77 files.
#> Side Effect : generates .f file.
#>-----------------------------------------------------------------<
sub DoCompile_byMake {    
   local($DemoDir, $targetF) = @_;
#>
#> Set environment variables.
#>
   $nlspath = "/usr/lib/nls/msg/%L/%N:/usr/lib/nls/msg/%L/%N.cat";
   $ENV{'NLSPATH'} = $nlspath;
   $ENV{'LANG'} = "en_US";
   $ENV{'PGI'}="/afs/theory/system/dest/rs_aix41/local/pghpf/003/app/pghpf";
   $ENV{'LM_LICENSE_FILE'}="/afs/theory/system/dest/rs_aix41/local/pghpf/003/app/pghpf/license.dat";

#>
#> Print information about the ongoing process.
#>
   local($cmnd) = "$targetF"."_"."$makecompiler";
   print STDOUT "<i>Compiling: (make $cmnd) ...</i><BR>";
   print STDOUT "<TEXTAREA NAME=\"DISPLAY\" ROWS=\"10\" COLS=\"70\">";

   &StartSwitchOut("stdout.dat", "stderr.dat");
   $stat = system("cd $DemoDir; make $cmnd");
   $stat >>= 8;
   print "\$stat is $stat and \$? is $? \n";
   &EndSwitchOut();
   
#   if ($stat) {
      do Print_File("stdout.dat");      
      do Print_File("stderr.dat");
#      print "Exiting ... \n";
      print "</TEXTAREA>";
#     die; 
#   }
#   else {
#      print "$compiler Compilation successful! \n";
#      print "</TEXTAREA>";
#   } 
   print "<HR>";
}

#>-----------------------------------------------------------------<
#> Function    : manages the HPF to F77+MP  translation by using Compilers.
#> In Arguments: names of the HPF and F77 files in $files list,
#>               name of TARGET and name of user's lab directory.
#> Side Effect : generates .f file.
#>-----------------------------------------------------------------<
sub DoCompile_byCompiler {    
   local($DemoDir, $targetF, $files) = @_;
   
   local($flags1) = "-fixed "; 
   local($flags2) = "-fixed -wsf";

   local($cmnd) = "f90 ";
   if ($compiler eq "F90") {
       local($target) = $targetF."_"."F90";
       $cmnd .= " -o $target $flags1 $files";
   } elsif ($compiler eq "HPF") {
       local($target) = $targetF."_"."HPF";
       $cmnd .= " -o $target $flags2 $files"; 
   } else {
       &htmlDie("Compile: Wrong arguments cmnd=$cmnd.");
   }
   print "<i>Compiling: ($cmnd) ...</i><BR>";
   $cmnd = "cd $DemoDir; $cmnd";
   print STDOUT "<TEXTAREA NAME=\"DISPLAY3\" ROWS=\"10\" COLS=\"70\">";

   $stat = system("cd $DemoDir; $cmnd >compile.log  2>&1");
   $stat >>= 8;

#   print "\$stat is $stat and \$? is $? \n";

   do Print_File("$DemoDir/compile.log");
   if ($stat) {
      print "DEBUG: \$stat is $stat and \$? is $? \n";
      print "Exiting ... \n";
      print "</TEXTAREA>";
      die; 
   }
   else {
      print "DEBUG:\$stat is $stat and \$? is $? \n";
      print "Compilation is successful! \n";
      print "</TEXTAREA>";
   } 
   print "<HR>";

   # print "\$stat = $stat<p>";
}

#>-----------------------------------------------------------------<
#> Function    : manages the execution process.
#> In Arguments: name of the target file and number of nodes required.
#> Side Effect : output is shown on an edit window.
#>-----------------------------------------------------------------<
sub DoExecute {
   local($numNodes, $DemoDir, $targetF, $ext, $inputF, $outputF ) = @_;

# Give the user a message before you start execution
   print "<br><i>";

   local($target) = $targetF."_".$ext;

#>
#> Naturally the following would not work. We would need 
#> redirection of stdin. We handle output files by compying
#> stdout.dat to outputfile after execution.
#>
#>   $cmnd .= "< $inputF" if ($inputF);
#>   $cmnd .= "> $outputF" if ($outputF); 

   if ($compiler eq "F90") {
       local($cmnd) = "./$target";
       print "Executing serial Fortran90 code ($cmnd) on NPAC Alphafarm ...";
   }
   else {
       local($cmnd) = "./$target -farm alphafarm -peers $numNodes";
       print "Executing HPF code ($cmnd) on $numNodes node";
       print "s " unless ($numNodes == 1); 
       print "of NPAC Alphafarm ...";
   }
   print " </i><BR>";

   print STDOUT "<TEXTAREA NAME=\"DISPLAY3\" ROWS=\"10\" COLS=\"70\">";

   $stat=system("limit cputime 3:00");
   $cmnd = "./example_F90";
   $stat = system("cd $DemoDir; $cmnd >execute.log  2>&1");
#>
#> If outputfile is specified, just write a completion message. 
#>
   do Print_File("$DemoDir/execute.log");

   if ($stat) {
      print "DEBUG: \$stat = $stat \n";
      print "Execution (i.e.,$cmnd) failed :-> \n $! \n";
   }
   else {
      print "DEBUG: \$stat = $stat \n";
      print "Execution completed successfully!";

   }

   if ($outputfile) {
       print "Execution completed...";
       system("cp stdout.dat $DemoDir/$outputfile");
   } 
   print "</TEXTAREA><HR> \n";

   
}

#>-----------------------------------------------------------------<
#> Function    : sets the MP_ variables when it requested by the user.
#> In Arguments: The variables used to set MP_ environment variables.
#> Side Effect : A new environment containing new variables is generated.
#>-----------------------------------------------------------------<
sub DoSetMPEnv {
    $ENV{'MP_PROCS'} = $numNodes;
    $ENV{'MP_RMPOOL'} = $rmpool;
    $ENV{'MP_LABELIO'} = $labelio;
    $ENV{'MP_EUIDEVICE'} = $euidevice;
}

#>-----------------------------------------------------------------<
#> Function    : sets all flags and variables used in this script 
#>               according to user's selections.
#> In Arguments: $MY_DATA
#> Side Effect : All variables/flags given below are set.
#>-----------------------------------------------------------------<
sub Set_Compiler_Flags{
    local($i, $fldname);
    $setenv        = ($MYDATA{'TASK.SETENV'}) ? 1 : 0;
    $numNodes      = $MYDATA{'MP_PROCS'};
    $rmpool        = $MYDATA{'MP_RMPOOL'};
    $labelio       = $MYDATA{'MP_LABELIO'};
    $euidevice     = $MYDATA{'MP_EUIDEVICE'};
    $executablename= $MYDATA{'EXECUTABLE_NAME'};

    $compile       = ($MYDATA{'TASK.COMPILE'}) ? 1 : 0;
    $compilemethod = $MYDATA{'COMPILE_METHOD'};
    $compiler      = $MYDATA{'DEC_COMPILER'};
    $makecompiler  = $MYDATA{'MAKE_COMPILER'}; 
  
    $execute       = ($MYDATA{'TASK.RUN'})     ? 1 : 0;
    $executablefile= $MYDATA{'EXECUTABLE_FILE'};
    $inputfile     = $MYDATA{'INPUT_FILE'}; 
    $outputfile    = $MYDATA{'OUTPUT_FILE'};

    $num_compilable= $MYDATA{'NUM_COMPILABLE'};
    $files_to_be_compiled = "";
    for ($i = 0; $i < $num_compilable; $i++) {
        $fldname = "COMPILABLE.$i";
        if ($MYDATA{$fldname}) {
	    $files_to_be_compiled .= $MYDATA{$fldname};
            $files_to_be_compiled .= " ";
        }
    }
}
#>-----------------------------------------------------------------<
#> Function    : prints debugging statements.
#> In Arguments: chosen variables/flags of the script.
#> Side Effect : Chosen variables/flags are printed out.
#>-----------------------------------------------------------------<
sub Print_Debugging_Stmts {
    print "A few debugging stmts:";
    print "<blockquote>";

    print "username: $username <br>";

    print "compile:  $compile <br>";
    print "execute:  $execute <br>";
    print "numNodes: $numNodes <br>";

    print "compilemethod: $compilemethod <BR>";
    print "makecompiler:  $makecompiler <BR>";
    print "compiler:    $compiler <BR>";
    print "num_compilable:$num_compilable <BR>";
    print "files_to_be_compiled: $files_to_be_compiled <BR>";
    
    print "MP_ variables: $numNodes, $rmpool, $labelio, euidevice <BR>";
    print "inputfile:     $inputfile <BR>";
    print "outputfile:    $outputfile <BR>";

    print "targetFile:    $targetFile <BR>";
    print "</blockquote>";
    print "End of the debugging stmts<p>";
}

#
# -------------------- M A I N --------------------
#
   &Read_Query_String();
   &Parse_Query_String();
   &Define_Constants();

   #$username = $ENV{'REMOTE_USER'}; 
   #if (! $username) { &htmlDie("Username is not set, security flaw !!!");}
#>
#>-Fill in parameters 
#> 
    if ($MYDATA{'IMPORT'} ne "") {      # IMPORT was selected. 
       #&Print_Debugging_Stmts(); sleep(3);
       do DoImport("$DemoDir/$MYDATA{'DEMO.PROGRAMS'}");
       do htmlDie("Never supposed to return here!");
    }

    &Print_Page_Header();
#>
#>- Set Compiler Flags   
#>
    &Set_Compiler_Flags();
#>
#> A few debugging stmts
#>
   &Print_Debugging_Stmts();

   if ($compile) {
       if ($compilemethod eq "use_make") {
	   &DoCompile_byMake($DemoDir, $targetFile);
       }else {
           &DoCompile_byCompiler($DemoDir, $targetFile, $files_to_be_compiled);
       }
   }

   if ($setenv) {
      &DoSetMPEnv();
   }
 
   if ($execute) {
       if ($executablename eq "default") {
	   if ($compile) {
#>
#> The extension of the executable file is determined
#> according to the chosen compiler.
#>
              if ($compilemethod eq "use_make") { 
		  $ext = $makecompiler;
              } elsif ($compilemethod eq "use_compiler") {
                  $ext = $compiler;
              }    
	   }
           else {
              $ext = "serial"; # fix it later
           }
       } else {
           $ext = $executablename;
       } 
       &DoExecute($numNodes, $DemoDir, $targetFile, $ext, 
                  $inputFile, $outputFile);
   }
   print "</BODY>\n";
   print "</HTML>\n";

