#!/usr/local/bin/perl

#*------------------------------------------------*
#* COPYRIGHT (C) 1996                             *
#*         Northeast Parallel Architectures Center*
#*         Syracuse University                    *
#*------------------------------------------------*

#$Id: query-string.pl,v 1.1 1996/08/21 04:42:59 dincer Exp dincer $
#$Log: query-string.pl,v $
#Revision 1.1  1996/08/21 04:42:59  dincer
#Initial revision - Actually this is the second version, I lost the 
# rcs files for the initial version.
#
#% Revision 1.1  1996/07/26  15:03:32  dincer
#% Initial revision
#% Author: Kivanc Dincer, NPAC 1996.


#Can't modify subroutine entry in scalar assignment at query-string.pl line
#16, near ""0";"

#>-----------------------------------------------------------------<
#> Function    : reads in query string from stdin.
#> In Arguments: Envrionment variables REQUEST_METHOD, CONTENT_LENGTH.
#> Side Effect : writes input to $FORM_DATA.
#>-----------------------------------------------------------------<
sub main'Read_Query_String {
   local($START, $C, $LENGTH, $SAVE_LENGTH); 
   if ($ENV{'REQUEST_METHOD'} eq "GET") {        # Using GET..
      $FORM_DATA = $ENV{'QUERY_STRING'};         # Save data to FORM_DATA
#do htmlDie("GET");
   } else {                                      # Using POST..
      $LENGTH = $ENV{'CONTENT_LENGTH'};          # How much data to read?
      $SAVE_LENGTH = $LENGTH;
#do htmlDie("PUT");
      if ($LENGTH > "65536") { #32768") {   #16384") {
         do htmlDie("major network spam, stopped: PUT");
      }
      while ($LENGTH--) {
         $C = getc(STDIN);
         if ($C eq "=" || $C eq "&") {          # Check for start/end of value
           $START = "0";
        } else {
           $START++;
        }
        if ($START <= "65536") { # 16384") {       # 64K should be enough!
           $FORM_DATA .= $C;                    # Save data to FORM_DATA
        }
      }
   }
   return;
}

#>-----------------------------------------------------------------<
#> Function    : Parses query string stored in $FORM_DATA.
#> In Arguments: uses global variable $FORM_DATA.
#> Side Effect : updates $NUM, $NAME and $MYDATA.
#>-----------------------------------------------------------------<
sub main'Parse_Query_String {
   foreach (split(/&/, $FORM_DATA)) {
     ($NAME, $VALUE) = split(/=/, $_);
     $NAME =~ s/\+/ /g;
     $NAME =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
     $VALUE=~ s/\+/ /g;
     $VALUE=~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;
     # Find unique name
     $NUM = "0";
     while ($MYDATA{$NAME} ne "") {
        $NUM++;
        $NAME =~ s/\.([0-9]+$)|$/\.$NUM/;
     }
     # Store NAME=VALUE pair
     $MYDATA{$NAME} = $VALUE;
 }
 return;
}

1;
