/*
 * File         : Group.java
 * Author       : Xinying Li
 * Created      : Thu Apr  9 12:22:15 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/08/26 18:49:57 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

package mpi;
import mpi.*;

public class Group{
  public final static int EMPTY = 0;

  private static native void init(); 
  protected long handle;

  public Group() {}
  public Group(int Type) { GetGroup(Type); }
  public Group(long _handle) { handle = _handle;}
  protected native void GetGroup(int Type);

  public native int Size();
  public native int Rank();

  public native void finalize();

  public static native int [] Translate_ranks(Group group1,int [] ranks1,
	Group group2);
  public static native int Compare(Group group1,Group group2);
 
  private static native long union(Group group1,Group group2);
  public static Group Union(Group group1,Group group2)
  {  return new Group(union(group1,group2));
	 }
  private static native long intersection(Group group1,Group group2);
  public static Group Intersection(Group group1,Group group2)
  {  return new Group(intersection(group1,group2));
     }
  private static native long difference(Group group1,Group group2);
  public static Group Difference(Group group1,Group group2)
  {  return new Group(difference(group1,group2));
     }

  private native long incl(int [] ranks);
  public Group Incl(int [] ranks)
  {  return new Group(incl(ranks));
     }
  private native long excl(int [] ranks);
  public Group Excl(int [] ranks)
  {  return new Group(excl(ranks));
     }
  private native long range_incl(int [][] ranges );
  public Group Range_incl(int [][] ranges)
  {  return new Group(range_incl(ranges));
     }
  private native long range_excl(int [][] ranges );
  public Group Range_excl(int [][] ranges)
  {  return new Group(range_excl(ranges));
     }

  static {
    init();
  }          

}

